/* tento program simuluje paralelny zivot "mravcov" v bludisku, podla metod
 * ANT COLONY algoritmov s niektorymi vlastnymi upravami
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "support/commS.h"

#define PRINT_PATH FALSE
#define DELAY 600 /* 60000 */   /* delay medzi dvoma krokmi v mikrosec. */
#define NANTS 12

typedef struct tpath{
   char val; 
   struct tpath *prev, *next;
} Tpath;


int maxx, maxy;
int col[NANTS];
Tpath *path[NANTS];
int buffer=TRUE;   /* rozhoduje o tom ci si zapametavam cestu alebo nie */

void Forward(Tant *ant)
{
      if (PRINT_PATH) printf("q");
      if ( ant->pos.dir == 0 ) ant->pos.x++;
      if ( ant->pos.dir == 1 ) ant->pos.y++;
      if ( ant->pos.dir == 2 ) ant->pos.x--;
      if ( ant->pos.dir == 3 ) ant->pos.y--;
}

void Back(Tant *ant)
{
      if (PRINT_PATH) printf("z");
      if ( ant->pos.dir == 0 ) ant->pos.x--;
      if ( ant->pos.dir == 1 ) ant->pos.y--;
      if ( ant->pos.dir == 2 ) ant->pos.x++;
      if ( ant->pos.dir == 3 ) ant->pos.y++;
}

void Left(Tant *ant)
{
      if (PRINT_PATH) printf("k");
      if (ant->pos.dir == 0) ant->pos.dir = 3; else ant->pos.dir--;
}

void Right(Tant *ant)
{
      if (PRINT_PATH) printf("l");
      ant->pos.dir = (ant->pos.dir + 1) % 4;
}

short behave(int srv, Tant *s1)
{
short vyst;
long lf,fw;
long rulet;
struct { int pc,v; } p,dir[3];
Tpath *pom;

  content(srv,s1);
  col[s1->ID] = s1->inf;
  if (s1->inf == -1) {		/* rozhodovanie na ceste od potravy  */
    buffer = FALSE;
    pom = path[s1->ID];
    if (pom == NULL) 
	    return 3;  /* ak som uz v dome tak nerob nic */
    if (pom->next != NULL) path[s1->ID] = pom->next;
    vyst = pom->val;
/*    free(pom);     */
    if (vyst != 2) vyst = 1 - vyst; 
    return vyst;
  } else { 		/* rozhodovanie na ceste k potrave */
    if (s1->inf == -2) {        /* najlepsi mravec opakuje svoju cestu */
      buffer = FALSE;
      pom = path[s1->ID];
      if (pom == NULL) 
	    return 3;  /* ak som uz v dome tak nerob nic */
      if (pom->prev != NULL) path[s1->ID] = pom->prev;
      vyst = pom->val;
/*      free(pom);     */
      return vyst;
    } else {			/* bezny hladajuci mravec */
      if ( s1->inf >= 4*(maxx+maxy) || 
	   s1->inf > 2*(maxx + maxy )	 
           && random() % (4*(maxx+maxy) - s1->inf) == 0) {
        if (random() % 20 == 0)		/* som moc nespokojny */
	  s1->inf = 0;
	else
	  s1->inf = s1->inf - (maxx + maxy)/2 + random() % 7;   
	setContent(srv,s1); 
        dir[0].pc = 0;
        dir[0].v = s1->sens.lf;
        dir[1].pc = 1;
        dir[1].v = s1->sens.rt;
        dir[2].pc = 2;
        dir[2].v = s1->sens.fw;    /* utriedim si vstupy */
        if (dir[0].v && (dir[0].v < dir[1].v || !dir[1].v)) {
	    p = dir[1];
	    dir[1] = dir[0];
	    dir[0] = p;
        } 
        if (dir[1].v && (dir[1].v < dir[2].v || !dir[2].v)) {
  	    p = dir[1];
	    dir[1] = dir[2];
	    dir[2] = p;
        }  
        if (dir[0].v && (dir[0].v < dir[1].v || !dir[1].v)) {
	    p = dir[1];
	    dir[1] = dir[0];
	    dir[0] = p;
        }  
       /* Sleduj vzdy najslabsiu cestu ak su rovnako silne, tak nahodne */
        if (dir[1].v > dir[2].v) return dir[2].pc;      
        if (dir[0].v > dir[1].v || !dir[0].v)     /* rovnaju sa 1 a 2 */
          return dir[(random() % 2) + 1].pc; 
        else 			 /* rovnaju sa vsetky tri */  
          return dir[random() % 3].pc; 
      } else {					/* som v pohode */
        lf = s1->sens.lf  * s1->sens.lf /* */;       /* rulette will */
        fw = s1->sens.fw  * s1->sens.fw /* */;
        rulet = lf + fw + s1->sens.rt  * s1->sens.rt/* */;
        rulet = random() % rulet;
        if (rulet < fw ) vyst = 2; else
          if (rulet < fw + lf) vyst = 0; else
            vyst = 1;
        return vyst;
      }
    }  
  }
}  

int sgn(int n) 
{
  if ( n ) return 1; else return 0;
}
  
void Alife (int s, int num)
{
Tant ant;
short int out;
Tpath *p;

  ant.ID = num;
  ant.sens = getSens(s,&ant);
  ant.pos = getPos(s,&ant);
    if (sgn(ant.sens.lf) + sgn(ant.sens.rt) + sgn(ant.sens.fw) 
      + sgn(ant.sens.bk) > 2) 
    {    						/* je tu krizovatka */
       out = behave(s, &ant);
       if (buffer) {
         if ((p = malloc(sizeof(Tpath))) == NULL) {
            perror("malloc");  /* something went wrong */
            exit(1);
         }   
         p->val = out;
         p->next = path[ant.ID];
         p->prev = NULL;
	 if (p->next != NULL) p->next->prev = p;
	 path[ant.ID] = p;
       } else buffer = TRUE;
       if (out == 0 ) { 
          Left(&ant); 
	  usleep(DELAY/NANTS);
	  Forward(&ant);
       } else
 	  if (out == 1){ 
	     Right(&ant); 
	     usleep(DELAY/NANTS);
	     Forward(&ant);
	  } else
	     if (out == 2) Forward(&ant);
    } else {					/* nie je tu krizovatka */
      if (ant.sens.fw)  Forward(&ant);
      else 
	  if (ant.sens.lf) { 
	     Left(&ant); 
	     usleep(DELAY/NANTS);
	     Forward(&ant); 
	  }
          else if (ant.sens.rt) { 
	        Right(&ant); 
	        usleep(DELAY/NANTS);
		Forward(&ant); 
	      }
 	      else {
	          Left(&ant);
		  Left(&ant);
	      }
    }
    setPos(s,&ant);
    usleep(DELAY/NANTS); 
    if ( home(s,&ant) ) {
	    printf("\nNo.%d is home!\n",ant.ID);
	    ant.inf = -1;
            setContent(s,&ant); 
	    Left(&ant);
	    Left(&ant);
	    usleep(DELAY/NANTS);
	    Forward(&ant);
	    usleep(DELAY/NANTS);
	    setPos(s,&ant);
	    p = path[ant.ID];
	    if (p->next == NULL) exit(1);
	 /*   while (p->next->next != NULL)
		  p = p->next;
	    free(p->next);
	    p->next = NULL;
  */  }
    if ( atStart(s,&ant) ) {
            content(s,&ant);
	    if (ant.inf < 0) {
	      printf("\nNo.%d is back at start!\n",ant.ID);
	      if ( AmIBest(s,&ant) ) { 
	         ant.inf = -2; 
	         path[ant.ID]->val = 2;
	      }
	      else {
		while (path[ant.ID] != NULL) {
		  p = path[ant.ID];
		  path[ant.ID] = path[ant.ID]->prev;
		  free(p);
		}
		ant.inf = 0;
	      }
              setContent(s,&ant); 
	    } else {
		    /* ak navstivis domov bez potravy zabudni co si presiel */
	      while (path[ant.ID] != NULL) {
                p = path[ant.ID];
	        path[ant.ID] = p->next;
	        free(p);
	      }
	    }
	    Left(&ant);
	    Left(&ant);
	    setPos(s,&ant);
    }
    // printf("lf:%d  rt:%d  fw:%d  bk:%d\n",ant.sens.lf,ant.sens.rt,ant.sens.fw,ant.sens.bk);
}

main(int argc, char *argv[])  		/* abot.c */
{
int i,srv;
Tant home;
time_t tm;
FILE *f;

  i = 0;
  tm = time(NULL);
  srandom(tm);
  for(i=0;i<NANTS;i++) {
     col[i]=0;
     path[i]=NULL;
  }
  if (argc > 1) i = atoi(argv[1]);
  f = fopen("maze.draw", "r");
  fscanf(f,"%d",&maxy);
  fscanf(f,"%d",&maxx);
  fclose(f); 

  home.pos.x = -1; 	    /* special code, how to say put me on start */
  home.pos.y = -1;
  home.pos.dir = -1;
  
  srv = call_server();
  setACO(srv);
  clearfields(srv);
  for (i = 0;i<NANTS;i++){
    home.ID = i;  
    setPos(srv,&home);
  }
  while (TRUE) { 	 	/* cyklus generacii */
    i = 0;
    while (i < NANTS) { 		/* cyklus jednej generacie */  
      Alife(srv,i);
      i++;
    }
    for (i = 0;i<NANTS;i++)
      printf("c.%d: %2d,  ",i,col[i]);
    printf("\r");
    makeTimestep(srv);
    /* usleep(DELAY); */
  }
}

