#include "support/mlsock.c"
#include "support/gserv.c"
#include "support/commS.h"

#include <arpa/inet.h>
#include <unistd.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <signal.h>

/* tento program sa pripoji na server s uvedenou adresou, a tam vykresli
 * do programu Gserv.exe bludisko tak ako je zadane v maze.draw
 * server sa hlada podla IP, ktora je nastavena defaultne, ale moze sa 
 * posielat aj ako parameter.
 * Dalej vykresli robota, a v nekonecnej slucke ho hlada v bludisku a 
 * vykresluje ho na obrazovku, ak ziada o pohyb nemoznym smerom, tak ho
 * vykresli v poslednej korektnej pozicii.
 *
 * Dalej umoznuje zanechavanie feromonovej stopy, ktora sa zmensuje s casom.
 */

#define DEFAULT_IP "158.195.97.136"

#define NBOTS 18   	/* max. pocet sucasne beziacich botov */
#define PHRMN 500  	/* mnozstvo vypustaneho feromonu */
#define PHRMN_TIME 50  	/* cas vyparovania feromonu */

int VISUAL = TRUE;
int intr;	/* prerusenie signalom */
int maxx,maxy; 	/* rozmery bludiska */
int w,h; 	/* rozmery okna na serveri */
int kx,ky; 	/* koeficienty pomerov stran */
char HOST[16] = DEFAULT_IP;
short int maze[50][50];
int field[50][50];
Tant bot[NBOTS];
Tpos start = { 1, 1, 0 };	/* vychodzie postavenie robota */
Tpos homePos; 			/* pozicia ciela v bludisku */
int step[NBOTS];		/* pocitanie krokov robotom */
int best,beststep;		/* cislo robota s najkratsou trasou */ 
int wall;  	/* vyhodnocuje ci sme narazili alebo nie */
int done; 	/* urcuje stav konekcie */
int aco = TRUE; /* podpora Ant COlony algoritmov */ 
int col[24] = { 0x0000ff,0x00ffff,0x00ff00,0xffff00,0xff0000,0xff00ff,
		0x0000c0,0x00c0c0,0x00c000,0xc0c000,0xc00000,0xc000c0,
		0x8080ff,0x80ffff,0x80ff80,0xffff80,0xff8080,0xff80ff,
		0xc0c0ff,0xc0ffff,0xc0ffc0,0xffffc0,0xffc0c0,0xffc0ff};
int seda  = 0xc0c0c0;
int biela = 0xffffff;

void stvorec(int s, int px, int py)
{ 
 gserv_line(s, kx*px, ky*py, kx*px + (kx / 4), ky*py);
 gserv_line(s, kx*px + (kx / 4), ky*py, kx*px + (kx / 4), ky*py + (ky / 4));
 gserv_line(s, kx*px + (kx / 4), ky*py + (ky / 4), kx*px, ky*py + (ky / 4));
 gserv_line(s, kx*px, ky*py + (ky / 4), kx*px, ky*py);
}

void hobdl(int s, int px, int py)
{ 
 gserv_line(s, kx*px+(kx/4), ky*py, kx*px + kx, ky*py);
 gserv_line(s, kx*px + kx, ky*py, kx*px + kx, ky*py + (ky / 4));
 gserv_line(s, kx*px + kx, ky*py + (ky/4), kx*px+(kx/4), ky*py + (ky/4));
 gserv_line(s, kx*px+(kx/4), ky*py + (ky/4), kx*px+(kx/4), ky*py);
}

void vobdl(int s, int px, int py)
{ 
 gserv_line(s, kx*px, ky*py, kx*px, ky*py-(ky-ky/4));
 gserv_line(s, kx*px, ky*py-(ky-ky/4), kx*px+(kx/4), ky*py-(ky-ky/4));
 gserv_line(s, kx*px+(kx/4), ky*py-(ky-ky/4), kx*px+(kx/4), ky*py);
 gserv_line(s, kx*px+(kx/4), ky*py, kx*px, ky*py);
}

void draw_bot( int s, Tpos bot, int color )
{
 int k;
/* obdlznik s ciarkou v predu, stred pola bude v jeho strede. */
 gserv_setcolor( s, col[color] );
 if (kx < ky ) k = kx; else k = ky;
 gserv_line(s, kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8 - k/8, 
               kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8 - k/8);
 gserv_line(s, kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8 - k/8, 
               kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8 + k/8);
 gserv_line(s, kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8 + k/8, 
               kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8 + k/8);
 gserv_line(s, kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8 + k/8, 
               kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8 - k/8);
 if (bot.dir == 0)
   gserv_line(s, kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8, 
                 kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8);
 if (bot.dir == 1)
   gserv_line(s, kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8, 
                 kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8 + k/8);
 if (bot.dir == 2)
   gserv_line(s, kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8, 
                 kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8);
 if (bot.dir == 3)
   gserv_line(s, kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8, 
                 kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8 - k/8);
}	

void clear_bot( int s, Tpos bot )
{
int k;
/* obdlznik s ciarkou v predu, stred pola bude v jeho strede. */
 gserv_setcolor( s, biela );  /* biela */
 if (kx < ky ) k = kx; else k = ky;
 gserv_line(s, kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8 - k/8, 
               kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8 - k/8);
 gserv_line(s, kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8 - k/8, 
               kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8 + k/8);
 gserv_line(s, kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8 + k/8, 
               kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8 + k/8);
 gserv_line(s, kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8 + k/8, 
               kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8 - k/8);
 if (bot.dir == 0)
   gserv_line(s, kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8, 
                 kx*bot.x + 5*kx/8 + k/8, ky*bot.y + 5*ky/8);
 if (bot.dir == 1)
   gserv_line(s, kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8, 
                 kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8 + k/8);
 if (bot.dir == 2)
   gserv_line(s, kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8, 
                 kx*bot.x + 5*kx/8 - k/8, ky*bot.y + 5*ky/8);
 if (bot.dir == 3)
   gserv_line(s, kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8, 
                 kx*bot.x + 5*kx/8, ky*bot.y + 5*ky/8 - k/8);
}

void draw_home( int s, Tpos dom )
{
 int k;
/* inofarebny stvorec oznacujuci ciel */
 gserv_setcolor( s, seda );    /* seda */
 if (kx < ky ) k = kx; else k = ky;
 gserv_line(s, kx*dom.x + 5*kx/8 - k/4, ky*dom.y + 5*ky/8 - k/4, 
               kx*dom.x + 5*kx/8 + k/4, ky*dom.y + 5*ky/8 - k/4);
 gserv_line(s, kx*dom.x + 5*kx/8 + k/4, ky*dom.y + 5*ky/8 - k/4, 
               kx*dom.x + 5*kx/8 + k/4, ky*dom.y + 5*ky/8 + k/4);
 gserv_line(s, kx*dom.x + 5*kx/8 + k/4, ky*dom.y + 5*ky/8 + k/4, 
               kx*dom.x + 5*kx/8 - k/4, ky*dom.y + 5*ky/8 + k/4);
 gserv_line(s, kx*dom.x + 5*kx/8 - k/4, ky*dom.y + 5*ky/8 + k/4, 
               kx*dom.x + 5*kx/8 - k/4, ky*dom.y + 5*ky/8 - k/4);
 gserv_setcolor( s, 0 );
}	


void imagine_maze()
{
int i,j;
int c;
FILE *fname;

  fname = fopen("maze.draw","r");
  fscanf(fname,"%d", &maxy);
  fscanf(fname,"%d", &maxx); 
  c = getc( fname );

  for ( i = 1; i < maxx + 1; i++ ) {
    c = getc( fname );   // musim to citat, lebo je to naozaj v subore
    c = getc( fname );    
    maze[i*2][1]=1;      // vlastna reprezentacia
    maze[i*2-1][1]=1;
  }
  maze[maxx*2+1][1]=1;
  c = getc( fname );     // musim to citat, a ten druhy je EOLN 
  c = getc( fname );    
  for ( j = 2; j < maxy + 2; j++ ) {
    i = 0;
    while (( c = getc( fname )) != '\n') {
      i++;
      if (c == '1') {
        maze[i*2-1][(j-1)*2]=1;
      }
      else maze[i*2-1][(j-1)*2]=0;
      if ((c = getc( fname )) == '\n') break;
      maze[i*2][(j-1)*2]=0;
      if (c == '2') { 
	        printf("robot detected at %d,%d\n",i,j-1);
		start.x = i;
	        start.y = j-1;
	        start.dir = 0;
      }
      if (c == '3') { 
	        printf("home found at %d,%d\n", i,j-1);
		homePos.x = i;
	        homePos.y = j-1;
	        homePos.dir = 0;
		maze[i*2][(j-1)*2]=3;
      }
    }
    i = 0;
    while (( c = getc( fname )) != '\n') {
      i++;  
      if (c == '1') {
        maze[i*2-1][j*2-1]=1; }
      if (( c = getc( fname )) != '\n' ) {
        if ( c == '1'){ maze[i*2][j*2-1]=1;
	} else maze[i*2][j*2-1]=0;
      } else break;
    }
  }
  fclose(fname);
}
void draw_maze( int s )
{
int i,j;
int c;
FILE *fname;

  fname = fopen("maze.draw","r");
  fscanf(fname,"%d", &maxy);
  fscanf(fname,"%d", &maxx); 
  c = getc( fname );
  printf("getting window dimensions\n");
  w = gserv_width( s );
  h = gserv_height( s );
  printf("w: %d h: %d \n", w, h);
  kx = w / (maxx+2);  /*   + 2 preto, aby sa pocitalo aj s okrajmi */ 
  ky = h / (maxy+2);
  printf("kx: %d ky: %d \n", kx, ky);

  for ( i = 1; i < maxx + 1; i++ ) {
    stvorec(s, i, 1 );
    hobdl(s, i, 1 );
    c = getc( fname );   // musim to citat, lebo je to naozaj v subore
    c = getc( fname );    
    maze[i*2][1]=1;      // vlastna reprezentacia
    maze[i*2-1][1]=1;
  }
  stvorec(s, maxx + 1, 1 );
  maze[maxx*2+1][1]=1;
  c = getc( fname );     // musim to citat, a ten druhy je EOLN 
  c = getc( fname );    
  for ( j = 2; j < maxy + 2; j++ ) {
    i = 0;
    while (( c = getc( fname )) != '\n') {
      i++;
      if (c == '1') {
        vobdl(s, i, j);
        maze[i*2-1][(j-1)*2]=1;
      }
      else maze[i*2-1][(j-1)*2]=0;
      if ((c = getc( fname )) == '\n') break;
      maze[i*2][(j-1)*2]=0;
      if (c == '2') { 
	        printf("robot detected at %d,%d\n",i,j-1);
		start.x = i;
	        start.y = j-1;
	        start.dir = 0;
		/* setPos(start); */
      }
      if (c == '3') { 
	        printf("home placed at %d,%d\n", i,j-1);
		homePos.x = i;
	        homePos.y = j-1;
	        homePos.dir = 0;
		maze[i*2][(j-1)*2]=3;
		draw_home(s,homePos);
      }
    }
    i = 0;
    while (( c = getc( fname )) != '\n') {
      i++;  
      if (c == '1') {
        stvorec(s, i, j);
        maze[i*2-1][j*2-1]=1; }
      if (( c = getc( fname )) != '\n' ) {
        if ( c == '1'){
          hobdl(s, i, j);
          maze[i*2][j*2-1]=1;
	} else maze[i*2][j*2-1]=0;
      } else break;
    }
  }
  fclose(fname);
}

void refresh_scr(int s) {

int i,j;
int c;
FILE *fname;

  fname = fopen("maze.draw","r");
  fscanf(fname,"%d", &maxy);
  fscanf(fname,"%d", &maxx); 
  c = getc( fname );
  printf("Canvas refresh: getting window dimensions\n");
  w = gserv_width( s );
  h = gserv_height( s );
  printf("w: %d h: %d \n", w, h);
  kx = w / (maxx+2);  /*   + 2 preto, aby sa pocitalo aj s okrajmi */ 
  ky = h / (maxy+2);
  printf("kx: %d ky: %d \n", kx, ky);

  gserv_setcolor( s, 0 );  /* cierna */
  for ( i = 1; i < maxx + 1; i++ ) {
    stvorec(s, i, 1 );
    hobdl(s, i, 1 );
    c = getc( fname );   // musim to citat, lebo je to naozaj v subore
    c = getc( fname );    
    maze[i*2][1]=1;      // vlastna reprezentacia
    maze[i*2-1][1]=1;
  }
  stvorec(s, maxx + 1, 1 );
  maze[maxx*2+1][1]=1;
  c = getc( fname );     // musim to citat, a ten druhy je EOLN 
  c = getc( fname );    
  for ( j = 2; j < maxy + 2; j++ ) {
    i = 0;
    while (( c = getc( fname )) != '\n') {
      i++;
      if (c == '1') {
        vobdl(s, i, j);
        maze[i*2-1][(j-1)*2]=1;
      }
      else maze[i*2-1][(j-1)*2]=0;
      if ((c = getc( fname )) == '\n') break;
      maze[i*2][(j-1)*2]=0;
      if (c == '3') { 
	        printf("home placed at %d,%d\n", i,j-1);
		homePos.x = i;
	        homePos.y = j-1;
	        homePos.dir = 0;
		maze[i*2][(j-1)*2]=3;
		draw_home(s,homePos);
      } 
    }
    i = 0;
    while (( c = getc( fname )) != '\n') {
      i++;  
      if (c == '1') {
        stvorec(s, i, j);
        maze[i*2-1][j*2-1]=1; }
      if (( c = getc( fname )) != '\n' ) {
        if ( c == '1'){
          hobdl(s, i, j);
          maze[i*2][j*2-1]=1;
	} else maze[i*2][j*2-1]=0;
      } else break;
    }
  }
  fclose(fname);

}
	
Tsens updateSens(Tpos pos)
{
Tsens sens;
                           		/* Vyhodnotenie senzorov */
    if (pos.dir == 0){    		/* pri otoceni >  */ 
      sens.lf = maze[pos.x*2][pos.y*2-1];
      sens.rt = maze[pos.x*2][pos.y*2+1];
      sens.fw = maze[pos.x*2+1][pos.y*2];
      sens.bk = maze[pos.x*2-1][pos.y*2];
    }
    if (pos.dir == 1){                  /* pri otoceni \/ */
      sens.bk = maze[pos.x*2][pos.y*2-1];
      sens.fw = maze[pos.x*2][pos.y*2+1];
      sens.lf = maze[pos.x*2+1][pos.y*2];
      sens.rt = maze[pos.x*2-1][pos.y*2];
    }
    if (pos.dir == 2){                  /* pri otoceni <  */
      sens.rt = maze[pos.x*2][pos.y*2-1];
      sens.lf = maze[pos.x*2][pos.y*2+1];
      sens.bk = maze[pos.x*2+1][pos.y*2];
      sens.fw = maze[pos.x*2-1][pos.y*2];
    }
    if (pos.dir == 3){                  /* pri otoceni ^  */
      sens.fw = maze[pos.x*2][pos.y*2-1];
      sens.bk = maze[pos.x*2][pos.y*2+1];
      sens.rt = maze[pos.x*2+1][pos.y*2];
      sens.lf = maze[pos.x*2-1][pos.y*2];
    }
  if (aco) {
    if (pos.dir == 0){    		/* pri otoceni >  */ 
      if (1 - sens.fw) sens.fw=field[pos.y-1][pos.x]; else sens.fw = 0; 
      if (1 - sens.lf) sens.lf=field[pos.y-2][pos.x-1]; else sens.lf = 0;
      if (1 - sens.rt) sens.rt=field[pos.y][pos.x-1]; else sens.rt = 0;
      if (1 - sens.bk) sens.bk=field[pos.y-1][pos.x-2]; else sens.bk = 0;
    } 
    if (pos.dir == 1){    		/* pri otoceni \/ */ 
      if (1 - sens.lf) sens.lf=field[pos.y-1][pos.x]; else sens.lf = 0;
      if (1 - sens.bk) sens.bk=field[pos.y-2][pos.x-1]; else sens.bk = 0;
      if (1 - sens.fw) sens.fw=field[pos.y][pos.x-1]; else sens.fw = 0;
      if (1 - sens.rt) sens.rt=field[pos.y-1][pos.x-2]; else sens.rt = 0;
    }
    if (pos.dir == 2){    		/* pri otoceni <  */ 
      if (1 - sens.bk) sens.bk=field[pos.y-1][pos.x]; else sens.bk = 0; 
      if (1 - sens.rt) sens.rt=field[pos.y-2][pos.x-1]; else sens.rt = 0; 
      if (1 - sens.lf) sens.lf=field[pos.y][pos.x-1]; else sens.lf = 0; 
      if (1 - sens.fw) sens.fw=field[pos.y-1][pos.x-2]; else sens.fw = 0; 
    }
    if (pos.dir == 3){    		/* pri otoceni /\ */ 
      if (1 - sens.rt) sens.rt=field[pos.y-1][pos.x]; else sens.rt = 0; 
      if (1 - sens.fw) sens.fw=field[pos.y-2][pos.x-1]; else sens.fw = 0; 
      if (1 - sens.bk) sens.bk=field[pos.y][pos.x-1]; else sens.bk = 0; 
      if (1 - sens.lf) sens.lf=field[pos.y-1][pos.x-2]; else sens.lf = 0; 
    }
  }  
  return sens;
}

void clrflds()
{
int i,j;

  for (j=0;j<maxy;j++)
    for (i=0;i<maxx;i++)
      field[j][i] = 0;
}

int getflds()
{
int i,j,n;

  n = 0;
  for (i=0;i<maxx;i++)
    for (j=0;j<maxy;j++)
      if (field[i][j] != 0) n++;
  return n;
}

void visitfld( Tpos pos, int bn)
{
  if ( aco ) {
     if ( bn == best ) {
       field[pos.y-1][pos.x-1] = field[pos.y-1][pos.x-1] + PHRMN * 2;
     } else {
       if (field[pos.y-1][pos.x-1] > PHRMN) {
         field[pos.y-1][pos.x-1] = field[pos.y-1][pos.x-1] + PHRMN/20;    
       }
       else
         field[pos.y-1][pos.x-1] = field[pos.y-1][pos.x-1] + PHRMN;    
     }
  }
  else
    field[pos.y][pos.x]++;
}

void timestep()
{
int i,j,x;
float f1,f2;

  for (j=0;j<maxy;j++)
    for (i=0;i<maxx;i++)
      if (field[j][i] > 1) { 
	if (field[j][i] > PHRMN/2) {
           x = (0.4 * PHRMN_TIME * (1 -  (float)field[j][i] / PHRMN)+0.5);
	   field[j][i] = PHRMN - 2.5 * PHRMN / PHRMN_TIME * (x + 1);
	} else {
	  if (field[j][i] <= PHRMN/2 && field[j][i] >= PHRMN/5) { 
             x = (0.4 * PHRMN_TIME * (0.7 -  (float)field[j][i] / PHRMN)+0.5);
	     field[j][i] = 0.7 * PHRMN - PHRMN / PHRMN_TIME * (x + 1);
	  } else
	    if (field[j][i] < PHRMN/5) {
              x = (2.5 * PHRMN_TIME * (0.4 -  (float)field[j][i] / PHRMN)+0.5);
	      field[j][i] = 0.4 * PHRMN - 0.4 * PHRMN / PHRMN_TIME * (x + 1);
            }
	}
	if (field[j][i] < 1) field[j][i] = 1;
      }
  field[start.y-1][start.x-1] = 2000;
  field[homePos.y-1][homePos.x-1] = 2000;
}

void init_bots()
{
int i;

  for(i=0;i<NBOTS;i++){
    bot[i].pos = start;
    bot[i].sens = updateSens(start);
    if (aco) bot[i].inf = 0;
  }
}
int serve(int s,Tpos *pos)
{
int msg,n;

  n = recv(s, &msg, sizeof(int), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
     done = TRUE;
  }
  if (!done) 
    switch (msg) {
      case GETSENS :
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
	  if (!done && send(s, &bot[msg].sens, sizeof(Tsens), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }
	  *pos = bot[msg].pos;
	  break;
      case GETPOS : 
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
	  if (!done && send(s, &bot[msg].pos, sizeof(Tpos), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }    
	  *pos = bot[msg].pos;
	  break;
      case WALL : 
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
	  if (!done && send(s, &bot[msg].inf, sizeof(int), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }    
	  *pos = bot[msg].pos;
	  break;
      case HOME :
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
	  if (maze[bot[msg].pos.x*2][bot[msg].pos.y*2] == 3)
	    n = TRUE; else n = FALSE;
	  if (!done && send(s, &n, sizeof(int), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }    
	  *pos = bot[msg].pos;
	  break;
      case SETPOS :
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
          n = recv(s, pos, sizeof(Tpos), 0);
  	  if (n <= 0) {
   	    if (n < 0) perror("recv");
            done = TRUE;
  	  }
	  break;
      case CLEARFIELDS :
 	    clrflds();
	    n = TRUE;
	  if (send(s, &n, sizeof(int), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }    
	  msg = 0;
	  *pos = bot[msg].pos;
	  break;
      case GETNFIELDS :
	    n = getflds();
	  if (send(s, &n, sizeof(int), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }
	  msg = 0;
	  *pos = bot[msg].pos;
	  break;
      case ACOSIM :
	  aco = TRUE;
	  msg = 0;
	  *pos = bot[msg].pos;
	  break;
      case TIMESTEP :
	  timestep();
	  msg = 0;
	  *pos = bot[msg].pos;
	  break;
      case CONTENT : 
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
	  if (!done && send(s, &bot[msg].inf, sizeof(int), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }    
	  *pos = bot[msg].pos;
	  break;
      case SETCONT :
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
          n = recv(s, &bot[msg].inf, sizeof(int), 0);
  	  if (n <= 0) {
   	    if (n < 0) perror("recv");
            done = TRUE;
  	  }
	  *pos = bot[msg].pos;
	  break;
      case START :
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
	  if (bot[msg].pos.x == start.x && bot[msg].pos.y == start.y ) {
            if (step[msg] < beststep && bot[msg].inf == -1) { 
	       beststep = step[msg]; best = msg; }
	    step[msg] = 0;	 
	    n = TRUE; 
	  } else n = FALSE;
	  if (!done && send(s, &n, sizeof(int), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }    
	  *pos = bot[msg].pos;
	  break;
      case BEST :
          n = recv(s, &msg, sizeof(int), 0);
          if (n <= 0) {
             if (n < 0) perror("recv");
             done = TRUE;
          }
	  if ( msg == best )
	    n = TRUE; else n = FALSE;
	  if (!done && send(s, &n, sizeof(int), 0) < 0) {
	      perror("send");
              done = TRUE;
	  }    
	  *pos = bot[msg].pos;
	  break;
    }
  if (done) close(s);
  return msg;
}

int main( int argc, char *argv[] )
{
int s, Move, i, cntr;
int bn, client;
int delay;		/* pocet krokov na najdenie najkratsej cesty */
Tpos op, np;
Tsens sens;
void switch_visual(int sig); /* prototype */
void sig_refresh(int sig); /* prototype */

  if (VISUAL){
    if ( argc > 1 ) strncpy(HOST, argv[1], 16);
    s = inet_stream_connect( HOST, GSERVPORT );
    if( s == -1 )
    {
      perror( mlsock_fnfail );
      return 1;
    }
    gserv_reset( s );
    draw_maze( s );
    draw_bot ( s, start, 0 );
    if (signal(SIGUSR1, switch_visual) == SIG_ERR) {
       perror("signal");
       exit(1);
    }
    if (signal(SIGUSR2, sig_refresh) == SIG_ERR) {
       perror("signal");
       exit(1);
    }
  } else 
      imagine_maze();
  cntr = 0;
  clrflds();
  init_bots();
  np = bot[0].pos;
  op = np;
  done = TRUE;
  while ( TRUE )
  {
    if (done) { 
      beststep = 20000;  /* vela aby to hned prve prekonalo */
      best = -1; 
      done = FALSE; 
      printf("\n\nTento beh spotreboval %d krokov", delay);
      client = wait_client(); 
      delay = 0;
    }
    bn = serve(client,&np);
    if ( bn >= NBOTS ) { 
	    continue; 
	    done = FALSE;
    }
    op = bot[bn].pos;
    if (np.x == -1 && np.y == -1) {   /* someone want's go to start pos */
      printf("\nBot c.%d sa presuva na zaciatok.\n",bn);
      np = start;
      if (VISUAL){
        clear_bot( s, op );
        draw_bot ( s, np, bn );
      }
      bot[bn].pos = np;
      bot[bn].sens = updateSens(np);
      bot[bn].inf = 0;
      step[bn] = 0;
    }
    if ( op.x != np.x || op.y != np.y || op.dir != np.dir )
    { // printf("NewPos x: %d, y: %d, dir: %d - OldPos x: %d y: %d dir: %d\r",
      //    np.x, np.y, np.dir, op.x, op.y, op.dir);
      Move=1;
      if ( op.x != np.x || op.y != np.y )
      {                          // treba preverit ci nechcem prejst cez stenu
         if (op.x < np.x) if (maze[np.x*2-1][np.y*2]==1) Move=0;	 
         if (op.x > np.x) if (maze[np.x*2+1][np.y*2]==1) Move=0;
         if (op.y > np.y) if (maze[np.x*2][np.y*2+1]==1) Move=0;
         if (op.y < np.y) if (maze[np.x*2][np.y*2-1]==1) Move=0;
      
	 if (np.x < 1 || np.x > maxx) Move=0;
	 if (np.y < 1 || np.y > maxx) Move=0;
      }   
      if (maze[np.x*2][np.y*2] == 3){
	 printf("\nNo.%d hit the home after %d steps, best is %d, time %d\n", bn,  step[bn], best, delay);
	 if (step[bn] == step[best]) cntr++;
	 else cntr = 0;
	 if (cntr == NBOTS - 1) { getchar(); cntr = 0; } 
      }
      if (Move) {
	if (intr) {
	  if (intr == 1) { 
             VISUAL = !VISUAL; 
             for(i=0;i<NBOTS;i++){
                clear_bot(s, bot[i].pos);
             }
	  }
	  if (intr == 2) refresh_scr(s);
	  intr = 0;
	  biela = biela + seda;
	  seda = biela - seda;
	  biela = biela - seda;
	}
	delay++;
        if (VISUAL) {
          clear_bot( s, op );
          draw_bot ( s, np, bn );
	}
	visitfld (np, bn);
	step[bn]++;
        op.x = np.x;
        op.y = np.y;
        op.dir = np.dir;
        sens = updateSens(np);
	wall = FALSE;
	bot[bn].sens = sens;
	bot[bn].pos = op;
	if ( bot[bn].inf >= 0 ) bot[bn].inf++;
		
      } else {
	 wall = TRUE;
	 np = op;	/* treba ho vratit na povodne miesto lebo nabural */
      }
      if (!aco) bot[bn].inf = wall;
    }   				/* end  if (np != op) */  
   /* usleep( 100000 ); */
  }
  if (VISUAL) close( s );
  return 0;
}

void switch_visual(int sig) {

  intr = 1;
  if (signal(SIGUSR1, switch_visual) == SIG_ERR) {
     perror("signal");
     exit(1);
  }
}

void sig_refresh(int sig) {

  intr = 2;
  if (signal(SIGUSR2, sig_refresh) == SIG_ERR) {
     perror("signal");
     exit(1);
  }
}
