/* communication modul
 * used for communication between environment {drawmaze}
 * and any robot implementation, trought the UNIX sockets
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#include "commS.h"

#define VERBOSE TRUE

int wait_client()
{
int s, s2, t, len;
struct sockaddr_un local, remote;
char str[100];

  if ((s = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
      perror("socket");
      exit(1);
  }

  local.sun_family = AF_UNIX;
  strcpy(local.sun_path, SOCK_PATH);
  unlink(local.sun_path);
  len = strlen(local.sun_path) + sizeof(local.sun_family);
  if (bind(s, (struct sockaddr *)&local, len) == -1) {
      perror("bind");
      exit(1);
  }

  if (listen(s, 5) == -1) {
      perror("listen");
      exit(1);
  }
  if (VERBOSE) printf("Waiting for a connection... ");
  t = sizeof(remote);
  if ((s2 = accept(s, (struct sockaddr *)&remote, &t)) == -1) {
      perror("accept");
      exit(1);
  }
  if (VERBOSE) printf("Connected.\n");
  return s2;
}

int call_server(){
int s, t, len;
struct sockaddr_un remote;

  if ((s = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
       perror("socket");
       exit(1);
  }

  if (VERBOSE) printf("Trying to connect... ");

  remote.sun_family = AF_UNIX;
  strcpy(remote.sun_path, SOCK_PATH);
  len = strlen(remote.sun_path) + sizeof(remote.sun_family);
  if (connect(s, (struct sockaddr *)&remote, len) == -1) {
      perror("connect");
      exit(1);
  }

  if (VERBOSE) printf("Connected.\n");
  return s;
}
  
int home(int s, Tant *ant)
{
int n,msg,steps;

  msg = HOME;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &msg, sizeof(int), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
  return msg;
}

void hit_home(Tdna hp)
{
FILE *f;
Tdna read;	

  read.value = 100;
  if ((f = fopen ("./DNAbank/homeDNA","rb")) != NULL) {
    fread(&read.DNA[0],16 * sizeof(short),1,f);
    fread(&read.value,sizeof(int),1,f);
    fclose(f);
  }
  if (read.value > hp.value) {
    f = fopen ("./DNAbank/homeDNA","wb");
    fwrite(&hp.DNA[0],16 * sizeof(short),1,f);
    fwrite(&hp.value,sizeof(int),1,f);
    fwrite(&hp.generation,sizeof(int),1,f);
    fclose(f);
  }
}

int bump(int s, Tant *ant)
{
int n,msg;

  msg = WALL;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &msg, sizeof(int), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
  return msg;
}

void hit_bump(Tpos pos)
{
/*FILE *f;

  f = fopen ("bump.bot","wb");
  fwrite(&pos, sizeof(pos), 1, f);
  fclose(f);
*/}

Tsens getSens(int s, Tant *ant)
{
Tsens sens;
int n,msg;

  msg = GETSENS;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &sens, sizeof(Tsens), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
  return sens;
}

void setSens(Tsens sens)
{
/* FILE *f;         // nema viac zmysel lebo to robi len server 

  f = fopen ("sens.bot","wb");
  fwrite(&sens, sizeof(sens), 1, f);
  fclose(f);
*/
}

Tpos getPos(int s, Tant *ant)
{
Tpos pos;
int n,msg;

  msg = GETPOS;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &pos, sizeof(Tpos), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
  return pos;
}

void setPos(int s, Tant *ant)
{
int msg;

  msg = SETPOS;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->pos, sizeof(Tpos), 0) < 0) {
     perror("send");
  }
}

void clearfields(int s)
{
int n,msg;

  msg = CLEARFIELDS;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &msg, sizeof(int), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
}

int getNfields(int s)
{
int n,msg;

  msg = GETNFIELDS;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &msg, sizeof(int), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
  return msg;
}

void setACO(int s)
{
int msg;

  msg = ACOSIM;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
}


void makeTimestep(int s)
{
int msg;

  msg = TIMESTEP;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
}

void content(int s, Tant *ant)
{
Tpos pos;
int n,msg;

  msg = CONTENT;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &ant->inf, sizeof(int), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
}

void setContent(int s, Tant *ant)
{
int msg;

  msg = SETCONT;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->inf, sizeof(int), 0) < 0) {
     perror("send");
  }
}

int atStart(int s, Tant *ant)
{
int n,msg,steps;

  msg = START;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &msg, sizeof(int), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
  return msg;
}

int AmIBest(int s, Tant *ant)
{
int n,msg,steps;

  msg = BEST;
  if (send(s, &msg, sizeof(int), 0) < 0) {
     perror("send");
  }
  if (send(s, &ant->ID, sizeof(int), 0) < 0) {
     perror("send");
  }
  n = recv(s, &msg, sizeof(int), 0);
  if (n <= 0) {
     if (n < 0) perror("recv");
  }
  return msg;
}

