// gserv.cpp -> gserv.h

#include "gserv.h"

#include <sys/socket.h>

int gserv_reset( int s )
{
	if( gserv_clear( s, GSWHITE ) )
		return 1;
	return gserv_setcolor( s, GSBLACK );
}

int gserv_setcolor( int s, int c )
{
	char tmp = 'C';

	if( send( s, &tmp, 1, 0 ) != 1 )
		return 1;
	if( send( s, &c, 4, 0 ) != 4 )
		return 1;

	return 0;
}

int gserv_pixel( int s, int x, int y )
{
	char tmp = 'P';

	if( send( s, &tmp, 1, 0 ) != 1 )
		return 1;
	if( send( s, &x, 4, 0 ) != 4 )
		return 1;
	if( send( s, &y, 4, 0 ) != 4 )
		return 1;

	return 0;
}

int gserv_line( int s, int x1, int y1, int x2, int y2 )
{
	char tmp = 'L';

	if( send( s, &tmp, 1, 0 ) != 1 )
		return 1;
	if( send( s, &x1, 4, 0 ) != 4 )
		return 1;
	if( send( s, &y1, 4, 0 ) != 4 )
		return 1;
	if( send( s, &x2, 4, 0 ) != 4 )
		return 1;
	if( send( s, &y2, 4, 0 ) != 4 )
		return 1;

	return 0;
	
}

int gserv_clear( int s, int c )
{
	char tmp = 'X';

	if( send( s, &tmp, 1, 0 ) != 1 )
		return 1;
	if( send( s, &c, 4, 0 ) != 4 )
		return 1;

	return 0;
}

int gserv_width( int s )
{
	char tmp = 'w';
	int result;
	
	if( send( s, &tmp, 1, 0 ) != 1 )
		return -1;
	if( recv( s, &result, 4, 0 ) != 4 )
		return -1;

	return result;
}

int gserv_height( int s )
{
	char tmp = 'h';
	int result;
	
	if( send( s, &tmp, 1, 0 ) != 1 )
		return -1;
	if( recv( s, &result, 4, 0 ) != 4 )
		return -1;

	return result;
}
