#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <arpa/inet.h>

#include "mlsock.h"

const char * mlsock_fnfail;

int inet_stream_connect( const char * ip, int port )
{
	int tmp = socket( AF_INET, SOCK_STREAM, 0 );
	struct sockaddr_in addr;

	if( tmp == -1 )
	{
		mlsock_fnfail = "socket";
		return -1;
	}

	addr.sin_family = AF_INET;
	inet_aton( ip, &addr.sin_addr );
	addr.sin_port = htons( port );
	memset( &addr.sin_zero, 0, sizeof( addr.sin_zero ) );

	if( connect( tmp, &addr, sizeof( addr ) ) )
	{
		mlsock_fnfail = "connect";
		close( tmp );
		return -1;
	}

	return tmp;
}
